<?php
define("DOTCLEAR_CONF_FILE", dirname(__FILE__)."/../../blog/inc/config.php");

function listeBlogs() {
    global $mysqliConnec;
    $query = "SELECT blog_id, blog_url
              FROM ".DC_DBPREFIX."blog
              WHERE blog_status = 1";
    $result = mysqli_query($mysqliConnec, $query);
    $nb_enr = mysqli_num_rows($result);
    $liste = Array();
    for ($i = 0; $i < $nb_enr; $i++) {
        $row = mysqli_fetch_array($result);
        $liste[$i] = $row;
    }
    return $liste;
}

function publicUrl($blog_id) {
    global $mysqliConnec;
    $query = "SELECT setting_value
              FROM ".DC_DBPREFIX."setting
              WHERE setting_id = 'public_url'
                  AND (blog_id = NULL OR blog_id = '$blog_id')
              ORDER BY blog_id DESC
              LIMIT 0,1";
    $result = mysqli_query($mysqliConnec, $query);
    $nb_enr = mysqli_num_rows($result);
    $public_url = "";
    if ($nb_enr == 1) {
        $row = mysqli_fetch_array($result);
        return $row["setting_value"];
    }
    return false;
}

function chercheBillets($media, $blog_id) {
    global $mysqliConnec;
    $public_url = publicUrl($blog_id);
    $mediaFromPublic = substr($media, strpos($media, $public_url));
    $query = "SELECT post_url, blog_id, post_lang
              FROM ".DC_DBPREFIX."post
              WHERE (post_status = 1
                  AND blog_id = '$blog_id'
                  AND (post_content_xhtml LIKE '%$media%'
                      OR post_excerpt_xhtml LIKE '%$media%'
                      OR post_content_xhtml LIKE '%$mediaFromPublic%'
                      OR post_excerpt_xhtml LIKE '%$mediaFromPublic%'))
              ORDER BY post_dt DESC";
    $result = mysqli_query($mysqliConnec, $query);
    $nb_enr = mysqli_num_rows($result);
    $liste = Array();
    for ($i = 0; $i < $nb_enr; $i++) {
        $row = mysqli_fetch_array($result);
        $liste[$i] = $row;
    }
    return $liste;
}

function dcMediaHandler($askedFile) {
    global $mysqliConnec;
    include(DOTCLEAR_CONF_FILE);
    if (DC_DBDRIVER != "mysql") {
        return;
    }
    $mysqliConnec = mysqli_init();
    mysqli_real_connect($mysqliConnec, DC_DBHOST, DC_DBUSER, DC_DBPASSWORD);
    mysqli_select_db($mysqliConnec, DC_DBNAME);
    mysqli_query($mysqliConnec, "SET NAMES 'utf8'");
    
    $liste = listeBlogs();
    
    $billetsGlobal = Array();
    for ($i = 0; $i < sizeof($liste); $i++) {
        $billets = chercheBillets($askedFile, $liste[$i]["blog_id"]);
        for ($j = 0; $j < sizeof($billets); $j++) {
            $billets[$j]["blog_url"] = $liste[$i]["blog_url"];
            $billetsGlobal[] = $billets[$j];
        }
    }
    if (sizeof($billetsGlobal) > 0) {
        if (isset($_SERVER["HTTP_ACCEPT_LANGUAGE"])) {
            $langues = explode(",",$_SERVER["HTTP_ACCEPT_LANGUAGE"]);
            for ($i = 0; $i < sizeof($langues); $i++) {
                $langue = strtolower(substr(chop($langues[$i]),0,2));
                $billetsLangue = Array();
                for ($j = 0; $j < sizeof($billetsGlobal); $j++) {
                    if ($billetsGlobal[$j]["post_lang"] == $langue) {
                        $billetsLangue[] = $billetsGlobal[$j];
                    }
                }
                if (sizeof($billetsLangue) > 0) {
                    $billetsGlobal = $billetsLangue;
                    break;
                }
            }
        }
        $leBillet = $billetsGlobal[array_rand($billetsGlobal)];
        $urlBillet = $leBillet["blog_url"]."post/".$leBillet["post_url"];
        header("Content-Type: text/html; charset=UTF-8");
        redirect($askedFile, Array("replacement" => $urlBillet));
    }
}
?>
