<?php
/* $Id: get_browser.inc.php,v 1.1 2010/01/31 00:26:19 sarterm Exp $ */

/*
 * Renvoie un tableau décrivant le navigateur dans un format identique à
 * celui renvoyé par la fonction get_browser de PHP.
 *
 * @return Un tableau contenant les mêmes champs qu'un tableau renvoyé par
 *         get_browser().
 */
function get_browser2($user_agent = true, $return_array = false) {
	include_once(dirname(__FILE__)."/navigateur.cls.php");
	$IBDIN = new IBDNavigateur($user_agent);
	if ($return_array) {
		return $IBDIN->get_browser();
	}
	else {
		return (Object) $IBDIN->get_browser();
	}
}
?>